Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.cpp	(revision 86095)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.cpp	(revision 86096)
@@ -24,5 +24,4 @@
 #include "UICommon.h"
 #include "UIErrorString.h"
-#include "UIExtraDataManager.h"
 #include "UIFilePathSelector.h"
 #include "UIGlobalSettingsGeneral.h"
@@ -52,7 +51,7 @@
     bool operator!=(const UIDataSettingsGlobalGeneral &other) const { return !equal(other); }
 
-    /** Holds the default machine folder path. */
+    /** Holds the 'default machine folder' path. */
     QString m_strDefaultMachineFolder;
-    /** Holds the VRDE authentication library name. */
+    /** Holds the 'VRDE auth library' name. */
     QString m_strVRDEAuthLibrary;
 };
@@ -61,10 +60,9 @@
 UIGlobalSettingsGeneral::UIGlobalSettingsGeneral()
     : m_pCache(0)
-    , m_pLabelMachineFolder(0)
-    , m_pSelectorMachineFolder(0)
-    , m_pLabelVRDPLibraryName(0)
-    , m_pSelectorVRDPLibraryName(0)
-{
-    /* Prepare: */
+    , m_pLabelDefaultMachineFolder(0)
+    , m_pSelectorDefaultMachineFolder(0)
+    , m_pLabelVRDEAuthLibrary(0)
+    , m_pSelectorVRDEAuthLibrary(0)
+{
     prepare();
 }
@@ -72,5 +70,4 @@
 UIGlobalSettingsGeneral::~UIGlobalSettingsGeneral()
 {
-    /* Cleanup: */
     cleanup();
 }
@@ -84,13 +81,9 @@
     m_pCache->clear();
 
-    /* Prepare old general data: */
-    UIDataSettingsGlobalGeneral oldGeneralData;
-
-    /* Gather old general data: */
-    oldGeneralData.m_strDefaultMachineFolder = m_properties.GetDefaultMachineFolder();
-    oldGeneralData.m_strVRDEAuthLibrary = m_properties.GetVRDEAuthLibrary();
-
-    /* Cache old general data: */
-    m_pCache->cacheInitialData(oldGeneralData);
+    /* Cache old data: */
+    UIDataSettingsGlobalGeneral oldData;
+    oldData.m_strDefaultMachineFolder = m_properties.GetDefaultMachineFolder();
+    oldData.m_strVRDEAuthLibrary = m_properties.GetVRDEAuthLibrary();
+    m_pCache->cacheInitialData(oldData);
 
     /* Upload properties to data: */
@@ -100,23 +93,19 @@
 void UIGlobalSettingsGeneral::getFromCache()
 {
-    /* Get old general data from the cache: */
-    const UIDataSettingsGlobalGeneral &oldGeneralData = m_pCache->base();
-
-    /* Load old general data from the cache: */
-    m_pSelectorMachineFolder->setPath(oldGeneralData.m_strDefaultMachineFolder);
-    m_pSelectorVRDPLibraryName->setPath(oldGeneralData.m_strVRDEAuthLibrary);
+    /* Load old data from cache: */
+    const UIDataSettingsGlobalGeneral &oldData = m_pCache->base();
+    m_pSelectorDefaultMachineFolder->setPath(oldData.m_strDefaultMachineFolder);
+    m_pSelectorVRDEAuthLibrary->setPath(oldData.m_strVRDEAuthLibrary);
 }
 
 void UIGlobalSettingsGeneral::putToCache()
 {
-    /* Prepare new general data: */
-    UIDataSettingsGlobalGeneral newGeneralData = m_pCache->base();
-
-    /* Gather new general data: */
-    newGeneralData.m_strDefaultMachineFolder = m_pSelectorMachineFolder->path();
-    newGeneralData.m_strVRDEAuthLibrary = m_pSelectorVRDPLibraryName->path();
-
-    /* Cache new general data: */
-    m_pCache->cacheCurrentData(newGeneralData);
+    /* Prepare new data: */
+    UIDataSettingsGlobalGeneral newData = m_pCache->base();
+
+    /* Cache new data: */
+    newData.m_strDefaultMachineFolder = m_pSelectorDefaultMachineFolder->path();
+    newData.m_strVRDEAuthLibrary = m_pSelectorVRDEAuthLibrary->path();
+    m_pCache->cacheCurrentData(newData);
 }
 
@@ -126,5 +115,5 @@
     UISettingsPageGlobal::fetchData(data);
 
-    /* Update general data and failing state: */
+    /* Update data and failing state: */
     setFailed(!saveGeneralData());
 
@@ -135,9 +124,10 @@
 void UIGlobalSettingsGeneral::retranslateUi()
 {
-    m_pLabelMachineFolder->setText(tr("Default &Machine Folder:"));
-    m_pSelectorMachineFolder->setWhatsThis(tr("Holds the path to the default virtual machine folder. This folder is used, "
-                                              "if not explicitly specified otherwise, when creating new virtual machines."));
-    m_pLabelVRDPLibraryName->setText(tr("V&RDP Authentication Library:"));
-    m_pSelectorVRDPLibraryName->setWhatsThis(tr("Holds the path to the library that provides authentication for Remote Display (VRDP) clients."));
+    m_pLabelDefaultMachineFolder->setText(tr("Default &Machine Folder:"));
+    m_pSelectorDefaultMachineFolder->setWhatsThis(tr("Holds the path to the default virtual machine folder. This folder is used, "
+                                                     "if not explicitly specified otherwise, when creating new virtual machines."));
+    m_pLabelVRDEAuthLibrary->setText(tr("V&RDP Authentication Library:"));
+    m_pSelectorVRDEAuthLibrary->setWhatsThis(tr("Holds the path to the library that provides "
+                                                "authentication for Remote Display (VRDP) clients."));
 }
 
@@ -164,39 +154,39 @@
         pLayoutMain->setRowStretch(3, 1);
 
-        /* Prepare machine folder label: */
-        m_pLabelMachineFolder = new QLabel(this);
-        if (m_pLabelMachineFolder)
-        {
-            m_pLabelMachineFolder->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
-            pLayoutMain->addWidget(m_pLabelMachineFolder, 0, 0);
-        }
-        /* Prepare machine folder selector: */
-        m_pSelectorMachineFolder = new UIFilePathSelector(this);
-        if (m_pSelectorMachineFolder)
-        {
-            if (m_pLabelMachineFolder)
-                m_pLabelMachineFolder->setBuddy(m_pSelectorMachineFolder);
-            m_pSelectorMachineFolder->setHomeDir(uiCommon().homeFolder());
-
-            pLayoutMain->addWidget(m_pSelectorMachineFolder, 0, 1, 1, 2);
-        }
-
-        /* Prepare VRDP library name label: */
-        m_pLabelVRDPLibraryName = new QLabel(this);
-        if (m_pLabelVRDPLibraryName)
-        {
-            m_pLabelVRDPLibraryName->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
-            pLayoutMain->addWidget(m_pLabelVRDPLibraryName, 1, 0);
-        }
-        /* Prepare VRDP library name selector: */
-        m_pSelectorVRDPLibraryName = new UIFilePathSelector(this);
-        if (m_pSelectorVRDPLibraryName)
-        {
-            if (m_pLabelVRDPLibraryName)
-                m_pLabelVRDPLibraryName->setBuddy(m_pSelectorVRDPLibraryName);
-            m_pSelectorVRDPLibraryName->setHomeDir(uiCommon().homeFolder());
-            m_pSelectorVRDPLibraryName->setMode(UIFilePathSelector::Mode_File_Open);
-
-            pLayoutMain->addWidget(m_pSelectorVRDPLibraryName, 1, 1, 1, 2);
+        /* Prepare 'default machine folder' label: */
+        m_pLabelDefaultMachineFolder = new QLabel(this);
+        if (m_pLabelDefaultMachineFolder)
+        {
+            m_pLabelDefaultMachineFolder->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
+            pLayoutMain->addWidget(m_pLabelDefaultMachineFolder, 0, 0);
+        }
+        /* Prepare 'default machine folder' editor: */
+        m_pSelectorDefaultMachineFolder = new UIFilePathSelector(this);
+        if (m_pSelectorDefaultMachineFolder)
+        {
+            if (m_pLabelDefaultMachineFolder)
+                m_pLabelDefaultMachineFolder->setBuddy(m_pSelectorDefaultMachineFolder);
+            m_pSelectorDefaultMachineFolder->setHomeDir(uiCommon().homeFolder());
+
+            pLayoutMain->addWidget(m_pSelectorDefaultMachineFolder, 0, 1, 1, 2);
+        }
+
+        /* Prepare 'VRDE auth library' label: */
+        m_pLabelVRDEAuthLibrary = new QLabel(this);
+        if (m_pLabelVRDEAuthLibrary)
+        {
+            m_pLabelVRDEAuthLibrary->setAlignment(Qt::AlignRight | Qt::AlignVCenter);
+            pLayoutMain->addWidget(m_pLabelVRDEAuthLibrary, 1, 0);
+        }
+        /* Prepare 'VRDE auth library' editor: */
+        m_pSelectorVRDEAuthLibrary = new UIFilePathSelector(this);
+        if (m_pSelectorVRDEAuthLibrary)
+        {
+            if (m_pLabelVRDEAuthLibrary)
+                m_pLabelVRDEAuthLibrary->setBuddy(m_pSelectorVRDEAuthLibrary);
+            m_pSelectorVRDEAuthLibrary->setHomeDir(uiCommon().homeFolder());
+            m_pSelectorVRDEAuthLibrary->setMode(UIFilePathSelector::Mode_File_Open);
+
+            pLayoutMain->addWidget(m_pSelectorVRDEAuthLibrary, 1, 1, 1, 2);
         }
     }
@@ -214,24 +204,24 @@
     /* Prepare result: */
     bool fSuccess = true;
-    /* Save general settings from the cache: */
+    /* Save settings from cache: */
     if (fSuccess && m_pCache->wasChanged())
     {
-        /* Get old general data from the cache: */
-        const UIDataSettingsGlobalGeneral &oldGeneralData = m_pCache->base();
-        /* Get new general data from the cache: */
-        const UIDataSettingsGlobalGeneral &newGeneralData = m_pCache->data();
-
-        /* Save default machine folder: */
+        /* Get old data from cache: */
+        const UIDataSettingsGlobalGeneral &oldData = m_pCache->base();
+        /* Get new data from cache: */
+        const UIDataSettingsGlobalGeneral &newData = m_pCache->data();
+
+        /* Save 'default machine folder': */
         if (   fSuccess
-            && newGeneralData.m_strDefaultMachineFolder != oldGeneralData.m_strDefaultMachineFolder)
-        {
-            m_properties.SetDefaultMachineFolder(newGeneralData.m_strDefaultMachineFolder);
+            && newData.m_strDefaultMachineFolder != oldData.m_strDefaultMachineFolder)
+        {
+            m_properties.SetDefaultMachineFolder(newData.m_strDefaultMachineFolder);
             fSuccess = m_properties.isOk();
         }
-        /* Save VRDE auth library: */
+        /* Save 'VRDE auth library': */
         if (   fSuccess
-            && newGeneralData.m_strVRDEAuthLibrary != oldGeneralData.m_strVRDEAuthLibrary)
-        {
-            m_properties.SetVRDEAuthLibrary(newGeneralData.m_strVRDEAuthLibrary);
+            && newData.m_strVRDEAuthLibrary != oldData.m_strVRDEAuthLibrary)
+        {
+            m_properties.SetVRDEAuthLibrary(newData.m_strVRDEAuthLibrary);
             fSuccess = m_properties.isOk();
         }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.h	(revision 86095)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.h	(revision 86096)
@@ -38,8 +38,8 @@
 public:
 
-    /** Constructs General settings page. */
+    /** Constructs settings page. */
     UIGlobalSettingsGeneral();
-    /** Destructs General settings page. */
-    ~UIGlobalSettingsGeneral();
+    /** Destructs settings page. */
+    virtual ~UIGlobalSettingsGeneral() /* override */;
 
 protected:
@@ -71,5 +71,5 @@
     void cleanup();
 
-    /** Saves existing general data from the cache. */
+    /** Saves existing data from cache. */
     bool saveGeneralData();
 
@@ -79,12 +79,12 @@
     /** @name Widgets
      * @{ */
-        /** Holds machine folder label instance. */
-        QLabel             *m_pLabelMachineFolder;
-        /** Holds machine folder selector instance. */
-        UIFilePathSelector *m_pSelectorMachineFolder;
-        /** Holds VRDP library name label instance. */
-        QLabel             *m_pLabelVRDPLibraryName;
-        /** Holds VRDP library name selector instance. */
-        UIFilePathSelector *m_pSelectorVRDPLibraryName;
+        /** Holds 'default machine folder' label instance. */
+        QLabel             *m_pLabelDefaultMachineFolder;
+        /** Holds 'default machine folder' selector instance. */
+        UIFilePathSelector *m_pSelectorDefaultMachineFolder;
+        /** Holds 'VRDE auth library' label instance. */
+        QLabel             *m_pLabelVRDEAuthLibrary;
+        /** Holds 'VRDE auth library' selector instance. */
+        UIFilePathSelector *m_pSelectorVRDEAuthLibrary;
     /** @} */
 };