Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageBasic1.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageBasic1.cpp	(revision 86351)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageBasic1.cpp	(revision 86355)
@@ -357,4 +357,5 @@
         if (m_pSourceLayout)
         {
+            m_pSourceLayout->setContentsMargins(0, 0, 0, 0);
             m_pSourceLayout->setColumnStretch(0, 0);
             m_pSourceLayout->setColumnStretch(1, 1);
@@ -377,14 +378,14 @@
             }
 
-            /* Create description label: */
-            m_pLabelDescription = new QIRichTextLabel(this);
-            if (m_pLabelDescription)
-            {
-                /* Add into layout: */
-                m_pSourceLayout->addWidget(m_pLabelDescription, 1, 0, 1, 2);
-            }
-
             /* Add into layout: */
             pMainLayout->addLayout(m_pSourceLayout);
+        }
+
+        /* Create description label: */
+        m_pLabelDescription = new QIRichTextLabel(this);
+        if (m_pLabelDescription)
+        {
+            /* Add into layout: */
+            pMainLayout->addWidget(m_pLabelDescription);
         }
 
@@ -396,6 +397,6 @@
             m_pCloudContainerLayout->setColumnStretch(0, 0);
             m_pCloudContainerLayout->setColumnStretch(1, 1);
-            m_pCloudContainerLayout->setRowStretch(2, 0);
-            m_pCloudContainerLayout->setRowStretch(3, 1);
+            m_pCloudContainerLayout->setRowStretch(1, 0);
+            m_pCloudContainerLayout->setRowStretch(2, 1);
 
             /* Create profile label: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.cpp	(revision 86351)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/addcloudvm/UIWizardAddCloudVMPageExpert.cpp	(revision 86355)
@@ -61,5 +61,5 @@
                 {
                     m_pCloudContainerLayout->setContentsMargins(0, 0, 0, 0);
-                    m_pCloudContainerLayout->setRowStretch(3, 1);
+                    m_pCloudContainerLayout->setRowStretch(1, 1);
 
                     /* Create sub-layout: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp	(revision 86351)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp	(revision 86355)
@@ -764,4 +764,5 @@
                     m_pSettingsLayout2->setColumnStretch(0, 0);
                     m_pSettingsLayout2->setColumnStretch(1, 1);
+                    m_pSettingsLayout2->setRowStretch(4, 1);
 
                     /* Create profile label: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp	(revision 86351)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp	(revision 86355)
@@ -458,4 +458,5 @@
         if (m_pSourceLayout)
         {
+            m_pSourceLayout->setContentsMargins(0, 0, 0, 0);
             m_pSourceLayout->setColumnStretch(0, 0);
             m_pSourceLayout->setColumnStretch(1, 1);
@@ -478,14 +479,14 @@
             }
 
-            /* Create description label: */
-            m_pLabelDescription = new QIRichTextLabel(this);
-            if (m_pLabelDescription)
-            {
-                /* Add into layout: */
-                m_pSourceLayout->addWidget(m_pLabelDescription, 1, 0, 1, 2);
-            }
-
             /* Add into layout: */
             pMainLayout->addLayout(m_pSourceLayout);
+        }
+
+        /* Create description label: */
+        m_pLabelDescription = new QIRichTextLabel(this);
+        if (m_pLabelDescription)
+        {
+            /* Add into layout: */
+            pMainLayout->addWidget(m_pLabelDescription);
         }
 
@@ -505,5 +506,5 @@
                     m_pLocalContainerLayout->setColumnStretch(0, 0);
                     m_pLocalContainerLayout->setColumnStretch(1, 1);
-                    m_pLocalContainerLayout->setRowStretch(2, 1);
+                    m_pLocalContainerLayout->setRowStretch(1, 1);
 
                     /* Create file label: */
@@ -545,6 +546,6 @@
                     m_pCloudContainerLayout->setColumnStretch(0, 0);
                     m_pCloudContainerLayout->setColumnStretch(1, 1);
-                    m_pCloudContainerLayout->setRowStretch(2, 0);
-                    m_pCloudContainerLayout->setRowStretch(3, 1);
+                    m_pCloudContainerLayout->setRowStretch(1, 0);
+                    m_pCloudContainerLayout->setRowStretch(2, 1);
 
                     /* Create profile label: */
@@ -622,7 +623,4 @@
             pMainLayout->addLayout(m_pStackedLayout);
         }
-
-        /* Add vertical stretch finally: */
-        pMainLayout->addStretch();
     }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 86351)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 86355)
@@ -77,5 +77,5 @@
                         {
                             m_pLocalContainerLayout->setContentsMargins(0, 0, 0, 0);
-                            m_pLocalContainerLayout->setRowStretch(2, 1);
+                            m_pLocalContainerLayout->setRowStretch(1, 1);
 
                             /* Create file-path selector: */
@@ -106,5 +106,5 @@
                         {
                             m_pCloudContainerLayout->setContentsMargins(0, 0, 0, 0);
-                            m_pCloudContainerLayout->setRowStretch(3, 1);
+                            m_pCloudContainerLayout->setRowStretch(1, 1);
 
                             /* Create sub-layout: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageBasic1.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageBasic1.cpp	(revision 86351)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageBasic1.cpp	(revision 86355)
@@ -510,6 +510,6 @@
             m_pOptionsLayout->setColumnStretch(0, 0);
             m_pOptionsLayout->setColumnStretch(1, 1);
-            m_pOptionsLayout->setRowStretch(2, 0);
-            m_pOptionsLayout->setRowStretch(3, 1);
+            m_pOptionsLayout->setRowStretch(1, 0);
+            m_pOptionsLayout->setRowStretch(2, 1);
 
             /* Create profile label: */